
#ifndef __BLISTERBALL_H_INCLUDED__
#define __BLISTERBALL_H_INCLUDED__

#include "GpBaseClass.h"

#define NUMBALLS 10

const int	storeheight=48;
const int	borderwidth=5;
const int       ballsize=6;
const int	bounceperiod=128;
const int       scoreheight=20;
const int	gutterheight=24;
const int	turretwidth=17;
const int	bulletspeed=4;
const int	maxballdelta=48;
const int	minampl=32;

class BlisterBall : public GpBaseClass
{ 
public:
  BlisterBall();
  ~BlisterBall();
protected:
  virtual void Paint();
  virtual void KeyUp(int key);
  virtual void KeyDown(int key);
private:
  bool		ingame;

  int		ballsinplay;
  int		balldelta;
  int		player1score;
  int		player1lives;
  int		player1pos;
  int		player1dpos;
  bool	        player1fire;
  int		player1y;
  int		bullet1xpos;
  int		bullet1ypos;

  int		ballx[NUMBALLS];
  int	        bally[NUMBALLS];
  int		balldx[NUMBALLS];
  int		ballampl[NUMBALLS];
  int	   	ballpos[NUMBALLS];
  bool	   	ballinstore[NUMBALLS];

  void GameInit();
  void PlayGame();
  void HandleMovement();
  void CheckBallsInPlay();
  void ResetBall(int i);
  bool DrawBullet(int x, int y);
  void DoBullets();
  bool DrawTurret(int x, int y);
  void DrawBall(int x, int y);
  void DoBalls();
  void ShowIntroScreen();
  void DrawTurrets();
  void DrawPlayField();
  void ShowScore();
};

#endif

